<template>
  <div
    id="app"
    class="container"
    :class="[
      `page-${$route.name}`,
      {
        'sidebar-open': showSidebar,
        'has-token': token,
        'has-user-data': hasUserData
      }
    ]"
  >
    <div id="main">
      <router-view ref="sidebar" name="sidebar" />
      <keep-alive :include="[]">
        <transition name="route-change" mode="out-in">
          <router-view class="main-content" sticky-container />
        </transition>
      </keep-alive>
      <router-view ref="navbar" name="navbar" />
    </div>
    <v-message />
    <login-popup v-if="!token" />
    <loader
      v-if="$store.state.loading"
      :loading="$store.state.loading > 0"
      class="main-loading"
    />
  </div>
</template>

<script>
import LoginPopup from './components/includes/LoginPopup'
import { mapGetters } from 'vuex'
export default {
  name: 'App',
  components: { LoginPopup },
  syncStore: ['showSidebar'],
  syncSettings: ['token'],
  data() {
    return {
      interval: null
    }
  },
  computed: {
    ...mapGetters({
      hasUserData: 'user/hasData'
    })
  },
  mounted() {
    clearInterval(this.interval)
    this.interval = setInterval(() => {
      window.dispatchEvent(new Event('resize'))
    }, 700)
  },
  beforeDestroy() {
    clearInterval(this.interval)
  },
  methods: {}
}
</script>
